Scala Standard Library2.13.5 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection
  Definition Classes
    scala
-  package concurrent
  Definition Classes
    collection
-  package convert
  Definition Classes
    collection
-  package generic
  Definition Classes
    collection
-  package immutable
  Definition Classes
    collection
-  package mutable
  Definition Classes
    collection
- +:
- :+
- AbstractIndexedSeqView
- AbstractIterable
- AbstractIterator
- AbstractMap
- AbstractMapView
- AbstractSeq
- AbstractSeqView
- AbstractSet
- AbstractView
- AnyStepper
- ArrayOps
- BitSet
- BitSetOps
- BufferedIterator
- BuildFrom
- BuildFromLowPriority1
- BuildFromLowPriority2
- ClassTagIterableFactory
- ClassTagSeqFactory
- DefaultMap
- DoubleStepper
- EvidenceIterableFactory
- EvidenceIterableFactoryDefaults
- Factory
- Hashing
- IndexedSeq
- IndexedSeqOps
- IndexedSeqView
- IntStepper
- Iterable
- IterableFactory
- IterableFactoryDefaults
- IterableOnce
- IterableOnceExtensionMethods
- IterableOnceOps
- IterableOps
- Iterator
- JavaConverters
- LazyZip2
- LazyZip3
- LazyZip4
- LinearSeq
- LinearSeqOps
- LongStepper
- Map
- MapFactory
- MapFactoryDefaults
- MapOps
- MapView
- MapViewFactory
- Searching
- Seq
- SeqFactory
- SeqMap
- SeqOps
- SeqView
- Set
- SetOps
- SortedIterableFactory
- SortedMap
- SortedMapFactory
- SortedMapFactoryDefaults
- SortedMapOps
- SortedOps
- SortedSet
- SortedSetFactoryDefaults
- SortedSetOps
- SpecificIterableFactory
- Stepper
- StepperShape
- StepperShapeLowPriority1
- StepperShapeLowPriority2
- StrictOptimizedClassTagSeqFactory
- StrictOptimizedIterableOps
- StrictOptimizedLinearSeqOps
- StrictOptimizedMapOps
- StrictOptimizedSeqFactory
- StrictOptimizedSeqOps
- StrictOptimizedSetOps
- StrictOptimizedSortedMapOps
- StrictOptimizedSortedSetOps
- StringOps
- StringView
- View
- WithFilter

t

scala.collection

# IterableOnceOps

###

#### trait IterableOnceOps[+A, +CC[_], +C] extends Any

This implementation trait can be mixed into an `IterableOnce` to get the basic methods that are shared between `Iterator` and `Iterable`. The `IterableOnce` must support multiple calls to `iterator` but may or may not return the same `Iterator` every time.

Self Type
  IterableOnceOps[A, CC, C] with IterableOnce[A]
Source
  IterableOnce.scala

Linear Supertypes
Any
Known Subclasses
ValueSet, AbstractIndexedSeqView, AbstractIterable, AbstractIterator, AbstractMap, AbstractMapView, AbstractSeq, AbstractSeqView, AbstractSet, AbstractView, BitSet, BitSetOps, BufferedIterator, EvidenceIterableFactoryDefaults, IndexedSeq, IndexedSeqOps, IndexedSeqView, Appended, Concat, Drop, DropRight, Id, Map, Prepended, Reverse, Slice, Take, TakeRight, Iterable, IterableFactoryDefaults, IterableOps, Iterator, GroupedIterator, LinearSeq, LinearSeqOps, Map, MapFactoryDefaults, MapOps, KeySet, MapView, Filter, FilterKeys, Id, MapValues, TapEach, Seq, SeqMap, SeqOps, SeqView, Appended, Concat, Drop, DropRight, Id, Map, Prepended, Reverse, Sorted, Take, TakeRight, Set, SetOps, SortedMap, SortedMapFactoryDefaults, SortedMapOps, KeySortedSet, SortedSet, SortedSetFactoryDefaults, SortedSetOps, StrictOptimizedIterableOps, StrictOptimizedLinearSeqOps, StrictOptimizedMapOps, StrictOptimizedSeqOps, StrictOptimizedSetOps, StrictOptimizedSortedMapOps, StrictOptimizedSortedSetOps, StringView, View, Appended, Collect, Concat, DistinctBy, Drop, DropRight, DropWhile, Elems, Empty, Fill, Filter, FlatMap, Iterate, LeftPartitionMapped, Map, PadTo, Prepended, RightPartitionMapped, ScanLeft, Single, Tabulate, Take, TakeRight, TakeWhile, Unfold, Updated, Zip, ZipAll, ZipWithIndex, Map, TrieMap, ::, AbstractMap, AbstractSeq, AbstractSet, ArraySeq, ofBoolean, ofByte, ofChar, ofDouble, ofFloat, ofInt, ofLong, ofRef, ofShort, ofUnit, BitSet, HashMap, HashSet, IndexedSeq, IndexedSeqOps, IntMap, Iterable, LazyList, LinearSeq, LinearSeqOps, List, ListMap, ListSet, Node, LongMap, Map, Map1, Map2, Map3, Map4, WithDefault, MapOps, ImmutableKeySet, Nil, NumericRange, Exclusive, Inclusive, Queue, Range, Exclusive, Inclusive, Seq, SeqMap, SeqOps, Set, Set1, Set2, Set3, Set4, SetOps, SortedMap, WithDefault, SortedMapOps, ImmutableKeySortedSet, SortedSet, SortedSetOps, Cons, Empty, StrictOptimizedMapOps, StrictOptimizedSeqOps, StrictOptimizedSetOps, StrictOptimizedSortedMapOps, StrictOptimizedSortedSetOps, TreeMap, TreeSeqMap, TreeSet, Vector, VectorMap, WrappedString, AbstractBuffer, AbstractIterable, AbstractMap, AbstractSeq, AbstractSet, AnyRefMap, ArrayBuffer, ArrayBufferView, ArrayDeque, ArrayDequeOps, ArraySeq, ofBoolean, ofByte, ofChar, ofDouble, ofFloat, ofInt, ofLong, ofRef, ofShort, ofUnit, BitSet, Buffer, CollisionProofHashMap, HashMap, HashSet, IndexedBuffer, IndexedSeq, IndexedSeqOps, Iterable, LinkedHashMap, LinkedKeySet, LinkedHashSet, ListBuffer, LongMap, Map, WithDefault, MapOps, PriorityQueue, Queue, Seq, SeqMap, SeqOps, Set, SetOps, SortedMap, WithDefault, SortedMapOps, SortedSet, SortedSetOps, Stack, StringBuilder, TreeMap, TreeSet, UnrolledBuffer, WeakHashMap, BufferedSource, BufferedLineIterator, Source, LineIterator, Accumulator, AnyAccumulator, DoubleAccumulator, IntAccumulator, LongAccumulator, SystemProperties, MatchIterator, DefaultMap, BitSet1, BitSet2, BitSetN, Stream, ListMap, MultiMap, OpenHashMap
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. IterableOnceOps
2. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Abstract Value Members

1.  abstract def collect[B](pf: PartialFunction[A, B]): CC[B]

   Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

   Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

   B

     the element type of the returned collection.

   pf

     the partial function which filters and maps the collection.

   returns

     a new collection resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

2.  abstract def drop(n: Int): C

   Selects all elements except first n ones.

   Selects all elements except first n ones.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   n

     the number of elements to drop from this collection.

   returns

     a collection consisting of all elements of this collection except the first `n` ones, or else the empty collection, if this collection has less than `n` elements. If `n` is negative, don't drop any elements.

3.  abstract def dropWhile(p: (A) => Boolean): C

   Drops longest prefix of elements that satisfy a predicate.

   Drops longest prefix of elements that satisfy a predicate.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   p

     The predicate used to test elements.

   returns

     the longest suffix of this collection whose first element does not satisfy the predicate `p`.

4.  abstract def filter(p: (A) => Boolean): C

   Selects all elements of this collection which satisfy a predicate.

   Selects all elements of this collection which satisfy a predicate.

   p

     the predicate used to test elements.

   returns

     a new iterator consisting of all elements of this collection that satisfy the given predicate `p`. The order of the elements is preserved.

5.  abstract def filterNot(pred: (A) => Boolean): C

   Selects all elements of this collection which do not satisfy a predicate.

   Selects all elements of this collection which do not satisfy a predicate.

   pred

     the predicate used to test elements.

   returns

     a new collection consisting of all elements of this collection that do not satisfy the given predicate `pred`. Their order may not be preserved.

6.  abstract def flatMap[B](f: (A) => IterableOnce[B]): CC[B]

   Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections.

   Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections.

   For example:

       def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

   The type of the resulting collection is guided by the static type of collection. This might cause unexpected results sometimes. For example:

       // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
       def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

       // lettersOf will return a Set[Char], not a Seq
       def lettersOf(words: Seq[String]) = words.toSet flatMap ((word: String) => word.toSeq)

       // xs will be an Iterable[Int]
       val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

       // ys will be a Map[Int, Int]
       val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

   B

     the element type of the returned collection.

   f

     the function to apply to each element.

   returns

     a new collection resulting from applying the given collection-valued function `f` to each element of this collection and concatenating the results.

7.  abstract def flatten[B](implicit asIterable: (A) => IterableOnce[B]): CC[B]

   Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

   Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

   The resulting collection's type will be guided by the type of collection. For example:

       val xs = List(
                  Set(1, 2, 3),
                  Set(1, 2, 3)
                ).flatten
       // xs == List(1, 2, 3, 1, 2, 3)

       val ys = Set(
                  List(1, 2, 3),
                  List(3, 2, 1)
                ).flatten
       // ys == Set(1, 2, 3)

   B

     the type of the elements of each traversable collection.

   asIterable

     an implicit conversion which asserts that the element type of this collection is a `GenTraversable`.

   returns

     a new collection resulting from concatenating all element collections.

8.  abstract def getClass(): Class[_ <: AnyRef]

   Returns the runtime class representation of the object.

   Returns the runtime class representation of the object.

   returns

     a class object corresponding to the runtime type of the receiver.

   Definition Classes
     Any
9.  abstract def map[B](f: (A) => B): CC[B]

   Builds a new collection by applying a function to all elements of this collection.

   Builds a new collection by applying a function to all elements of this collection.

   B

     the element type of the returned collection.

   f

     the function to apply to each element.

   returns

     a new collection resulting from applying the given function `f` to each element of this collection and collecting the results.

10.  abstract def scanLeft[B](z: B)(op: (B, A) => B): CC[B]

    Produces a collection containing cumulative results of applying the operator going left to right, including the initial value.

    Produces a collection containing cumulative results of applying the operator going left to right, including the initial value.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    B

      the type of the elements in the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    returns

      collection with intermediate results

11.  abstract def slice(from: Int, until: Int): C

    Selects an interval of elements.

    Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

        from <= indexOf(x) < until

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    from

      the lowest index to include from this collection.

    until

      the lowest index to EXCLUDE from this collection.

    returns

      a collection containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this collection.

12.  abstract def span(p: (A) => Boolean): (C, C)

    Splits this collection into a prefix/suffix pair according to a predicate.

    Splits this collection into a prefix/suffix pair according to a predicate.

    Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the test predicate

    returns

      a pair consisting of the longest prefix of this collection whose elements all satisfy `p`, and the rest of this collection.

13.  abstract def take(n: Int): C

    Selects the first n elements.

    Selects the first n elements.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to take from this collection.

    returns

      a collection consisting only of the first `n` elements of this collection, or else the whole collection, if it has less than `n` elements. If `n` is negative, returns an empty collection.

14.  abstract def takeWhile(p: (A) => Boolean): C

    Takes longest prefix of elements that satisfy a predicate.

    Takes longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      The predicate used to test elements.

    returns

      the longest prefix of this collection whose elements all satisfy the predicate `p`.

15.  abstract def tapEach[U](f: (A) => U): C

    Applies a side-effecting function to each element in this collection.

    Applies a side-effecting function to each element in this collection. Strict collections will apply `f` to their elements immediately, while lazy collections like Views and LazyLists will only apply `f` on each element if and when that element is evaluated, and each time that element is evaluated.

    U

      the return type of f

    f

      a function to apply to each element in this collection

    returns

      The same logical collection as this

16.  abstract def zipWithIndex: CC[(A, Int)]

    Zips this collection with its indices.

    Zips this collection with its indices.

    returns

      A new collection containing pairs consisting of all elements of this collection paired with their index. Indices start at `0`.

    Example:

    1. `List("a", "b", "c").zipWithIndex == List(("a", 0), ("b", 1), ("c", 2))`

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any
2.  final def ##: Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toany2stringadd[IterableOnceOps[A, CC, C]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (IterableOnceOps[A, CC, C], B)
   Implicit
     This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toArrowAssoc[IterableOnceOps[A, CC, C]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any
6.  final def addString(b: mutable.StringBuilder): mutable.StringBuilder

   Appends all elements of this collection to a string builder.

   Appends all elements of this collection to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this collection without any separator string.

   Example:

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = new StringBuilder()
       b: StringBuilder =

       scala> val h = a.addString(b)
       h: StringBuilder = 1234

   b

     the string builder to which elements are appended.

   returns

     the string builder `b` to which elements were appended.

   Annotations
     @inline()
7.  final def addString(b: mutable.StringBuilder, sep: String): mutable.StringBuilder

   Appends all elements of this collection to a string builder using a separator string.

   Appends all elements of this collection to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this collection, separated by the string `sep`.

   Example:

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = new StringBuilder()
       b: StringBuilder =

       scala> a.addString(b, ", ")
       res0: StringBuilder = 1, 2, 3, 4

   b

     the string builder to which elements are appended.

   sep

     the separator string.

   returns

     the string builder `b` to which elements were appended.

   Annotations
     @inline()
8.  def addString(b: mutable.StringBuilder, start: String, sep: String, end: String): mutable.StringBuilder

   Appends all elements of this collection to a string builder using start, end, and separator strings.

   Appends all elements of this collection to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this collection are separated by the string `sep`.

   Example:

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = new StringBuilder()
       b: StringBuilder =

       scala> a.addString(b , "List(" , ", " , ")")
       res5: StringBuilder = List(1, 2, 3, 4)

   b

     the string builder to which elements are appended.

   start

     the starting string.

   sep

     the separator string.

   end

     the ending string.

   returns

     the string builder `b` to which elements were appended.

9.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10.  def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the collection for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the collection for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

11.  def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Int

    Copy elements to an array, returning the number of elements written.

    Copy elements to an array, returning the number of elements written.

    Fills the given array `xs` starting at index `start` with at most `len` elements of this collection.

    Copying will stop once either all the elements of this collection have been copied, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index of xs.

    len

      the maximal number of elements to copy.

    returns

      the number of elements written to the array

    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

12.  def copyToArray[B >: A](xs: Array[B], start: Int): Int

    Copy elements to an array, returning the number of elements written.

    Copy elements to an array, returning the number of elements written.

    Fills the given array `xs` starting at index `start` with values of this collection.

    Copying will stop once either all the elements of this collection have been copied, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index of xs.

    returns

      the number of elements written to the array

    Annotations
      @deprecatedOverriding(message = "This should always forward to the 3-arg version of this method", since = "2.13.4")
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

13.  def copyToArray[B >: A](xs: Array[B]): Int

    Copy elements to an array, returning the number of elements written.

    Copy elements to an array, returning the number of elements written.

    Fills the given array `xs` starting at index `start` with values of this collection.

    Copying will stop once either all the elements of this collection have been copied, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    returns

      the number of elements written to the array

    Annotations
      @deprecatedOverriding(message = "This should always forward to the 3-arg version of this method", since = "2.13.4")
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

14.  def corresponds[B](that: IterableOnce[B])(p: (A, B) => Boolean): Boolean

    Tests whether every element of this collection's iterator relates to the corresponding element of another collection by satisfying a test predicate.

    Tests whether every element of this collection's iterator relates to the corresponding element of another collection by satisfying a test predicate.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of `that`

    that

      the other collection

    p

      the test predicate, which relates elements from both collections

    returns

      `true` if both collections have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this iterator and `y` of `that`, otherwise `false`

15.  def count(p: (A) => Boolean): Int

    Counts the number of elements in the collection which satisfy a predicate.

    Counts the number of elements in the collection which satisfy a predicate.

    Note: will not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

16.  def ensuring(cond: (IterableOnceOps[A, CC, C]) => Boolean, msg: => Any): IterableOnceOps[A, CC, C]
    Implicit
      This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toEnsuring[IterableOnceOps[A, CC, C]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: (IterableOnceOps[A, CC, C]) => Boolean): IterableOnceOps[A, CC, C]
    Implicit
      This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toEnsuring[IterableOnceOps[A, CC, C]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  def ensuring(cond: Boolean, msg: => Any): IterableOnceOps[A, CC, C]
    Implicit
      This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toEnsuring[IterableOnceOps[A, CC, C]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
19.  def ensuring(cond: Boolean): IterableOnceOps[A, CC, C]
    Implicit
      This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toEnsuring[IterableOnceOps[A, CC, C]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
20.  def equals(arg0: Any): Boolean

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Any implementation of this method should be an equivalence relation:

    - It is reflexive: for any instance `x` of type `Any`, `x.equals(x)` should return `true`.
    - It is symmetric: for any instances `x` and `y` of type `Any`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
    - It is transitive: for any instances `x`, `y`, and `z` of type `Any` if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.

    If you override this method, you should verify that your implementation remains an equivalence relation. Additionally, when overriding this method it is usually necessary to override `hashCode` to ensure that objects which are "equal" (`o1.equals(o2)` returns `true`) hash to the same scala.Int. (`o1.hashCode.equals(o2.hashCode)`).

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any
21.  def exists(p: (A) => Boolean): Boolean

    Tests whether a predicate holds for at least one element of this collection.

    Tests whether a predicate holds for at least one element of this collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` is satisfied by at least one element of this collection, otherwise `false`

22.  def find(p: (A) => Boolean): Option[A]

    Finds the first element of the collection satisfying a predicate, if any.

    Finds the first element of the collection satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the collection that satisfies `p`, or `None` if none exists.

23.  def fold[A1 >: A](z: A1)(op: (A1, A1) => A1): A1

    Folds the elements of this collection using the specified associative binary operator.

    Folds the elements of this collection using the specified associative binary operator. The default implementation in `IterableOnce` is equivalent to `foldLeft` but may be overridden for more efficient traversal orders.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note: will not terminate for infinite-sized collections.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication).

    op

      a binary operator that must be associative.

    returns

      the result of applying the fold operator `op` between all the elements and `z`, or `z` if this collection is empty.

24.  def foldLeft[B](z: B)(op: (B, A) => B): B

    Applies a binary operator to a start value and all elements of this collection, going left to right.

    Applies a binary operator to a start value and all elements of this collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection, going left to right with the start value `z` on the left: `op(...op(z, x1), x2, ..., xn)` where `x1, ..., xn` are the elements of this collection. Returns `z` if this collection is empty.

25.  def foldRight[B](z: B)(op: (A, B) => B): B

    Applies a binary operator to all elements of this collection and a start value, going right to left.

    Applies a binary operator to all elements of this collection and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection, going right to left with the start value `z` on the right: `op(x1, op(x2, ... op(xn, z)...))` where `x1, ..., xn` are the elements of this collection. Returns `z` if this collection is empty.

26.  def forall(p: (A) => Boolean): Boolean

    Tests whether a predicate holds for all elements of this collection.

    Tests whether a predicate holds for all elements of this collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if this collection is empty or the given predicate `p` holds for all elements of this collection, otherwise `false`.

27.  def foreach[U](f: (A) => U): Unit

    Apply `f` to each element for its side effects Note: [U] parameter needed to help scalac's type inference.

28.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toStringFormat[IterableOnceOps[A, CC, C]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
29.  def hashCode(): Int

    Calculate a hash code value for the object.

    Calculate a hash code value for the object.

    The default hashing algorithm is platform dependent.

    Note that it is allowed for two objects to have identical hash codes (`o1.hashCode.equals(o2.hashCode)`) yet not be equal (`o1.equals(o2)` returns `false`). A degenerate implementation could always return `0`. However, it is required that if two objects are equal (`o1.equals(o2)` returns `true`) that they have identical hash codes (`o1.hashCode.equals(o2.hashCode)`). Therefore, when overriding this method, be sure to verify that the behavior is consistent with the `equals` method.

    returns

      the hash code value for this object.

    Definition Classes
      Any
30.  def isEmpty: Boolean

    Tests whether the collection is empty.

    Tests whether the collection is empty.

    Note: Implementations in subclasses that are not repeatedly traversable must take care not to consume any elements when `isEmpty` is called.

    returns

      `true` if the collection contains no elements, `false` otherwise.

31.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
32.  def isTraversableAgain: Boolean

    Tests whether this collection can be repeatedly traversed.

    Tests whether this collection can be repeatedly traversed. Always true for Iterables and false for Iterators unless overridden.

    returns

      `true` if it is repeatedly traversable, `false` otherwise.

33.  def max[B >: A](implicit ord: math.Ordering[B]): A

    Finds the largest element.

    Finds the largest element.

    Note: will not terminate for infinite-sized collections.

    B

      The type over which the ordering is defined.

    ord

      An ordering to be used for comparing elements.

    returns

      the largest element of this collection with respect to the ordering `ord`.

    Exceptions thrown

      `UnsupportedOperationException` if this collection is empty.

34.  def maxBy[B](f: (A) => B)(implicit cmp: math.Ordering[B]): A

    Finds the first element which yields the largest value measured by function f.

    Finds the first element which yields the largest value measured by function f.

    Note: will not terminate for infinite-sized collections.

    B

      The result type of the function f.

    f

      The measuring function.

    cmp

      An ordering to be used for comparing elements.

    returns

      the first element of this collection with the largest value measured by function f with respect to the ordering `cmp`.

    Exceptions thrown

      `UnsupportedOperationException` if this collection is empty.

35.  def maxByOption[B](f: (A) => B)(implicit cmp: math.Ordering[B]): Option[A]

    Finds the first element which yields the largest value measured by function f.

    Finds the first element which yields the largest value measured by function f.

    Note: will not terminate for infinite-sized collections.

    B

      The result type of the function f.

    f

      The measuring function.

    cmp

      An ordering to be used for comparing elements.

    returns

      an option value containing the first element of this collection with the largest value measured by function f with respect to the ordering `cmp`.

36.  def maxOption[B >: A](implicit ord: math.Ordering[B]): Option[A]

    Finds the largest element.

    Finds the largest element.

    Note: will not terminate for infinite-sized collections.

    B

      The type over which the ordering is defined.

    ord

      An ordering to be used for comparing elements.

    returns

      an option value containing the largest element of this collection with respect to the ordering `ord`.

37.  def min[B >: A](implicit ord: math.Ordering[B]): A

    Finds the smallest element.

    Finds the smallest element.

    Note: will not terminate for infinite-sized collections.

    B

      The type over which the ordering is defined.

    ord

      An ordering to be used for comparing elements.

    returns

      the smallest element of this collection with respect to the ordering `ord`.

    Exceptions thrown

      `UnsupportedOperationException` if this collection is empty.

38.  def minBy[B](f: (A) => B)(implicit cmp: math.Ordering[B]): A

    Finds the first element which yields the smallest value measured by function f.

    Finds the first element which yields the smallest value measured by function f.

    Note: will not terminate for infinite-sized collections.

    B

      The result type of the function f.

    f

      The measuring function.

    cmp

      An ordering to be used for comparing elements.

    returns

      the first element of this collection with the smallest value measured by function f with respect to the ordering `cmp`.

    Exceptions thrown

      `UnsupportedOperationException` if this collection is empty.

39.  def minByOption[B](f: (A) => B)(implicit cmp: math.Ordering[B]): Option[A]

    Finds the first element which yields the smallest value measured by function f.

    Finds the first element which yields the smallest value measured by function f.

    Note: will not terminate for infinite-sized collections.

    B

      The result type of the function f.

    f

      The measuring function.

    cmp

      An ordering to be used for comparing elements.

    returns

      an option value containing the first element of this collection with the smallest value measured by function f with respect to the ordering `cmp`.

40.  def minOption[B >: A](implicit ord: math.Ordering[B]): Option[A]

    Finds the smallest element.

    Finds the smallest element.

    Note: will not terminate for infinite-sized collections.

    B

      The type over which the ordering is defined.

    ord

      An ordering to be used for comparing elements.

    returns

      an option value containing the smallest element of this collection with respect to the ordering `ord`.

41.  final def mkString: String

    Displays all elements of this collection in a string.

    Displays all elements of this collection in a string.

    Delegates to addString, which can be overridden.

    returns

      a string representation of this collection. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection follow each other without any separator string.

    Annotations
      @inline()
42.  final def mkString(sep: String): String

    Displays all elements of this collection in a string using a separator string.

    Displays all elements of this collection in a string using a separator string.

    Delegates to addString, which can be overridden.

    sep

      the separator string.

    returns

      a string representation of this collection. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection are separated by the string `sep`.

    Annotations
      @inline()
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

43.  final def mkString(start: String, sep: String, end: String): String

    Displays all elements of this collection in a string using start, end, and separator strings.

    Displays all elements of this collection in a string using start, end, and separator strings.

    Delegates to addString, which can be overridden.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this collection. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this collection are separated by the string `sep`.

    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

44.  def nonEmpty: Boolean

    Tests whether the collection is not empty.

    Tests whether the collection is not empty.

    returns

      `true` if the collection contains at least one element, `false` otherwise.

    Annotations
      @deprecatedOverriding(message = "nonEmpty is defined as !isEmpty; override isEmpty instead", since = "2.13.0")
45.  def product[B >: A](implicit num: math.Numeric[B]): B

    Multiplies up the elements of this collection.

    Multiplies up the elements of this collection.

    Note: will not terminate for infinite-sized collections.

    B

      the result type of the `*` operator.

    num

      an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

    returns

      the product of all elements of this collection with respect to the `*` operator in `num`.

46.  def reduce[B >: A](op: (B, B) => B): B

    Reduces the elements of this collection using the specified associative binary operator.

    Reduces the elements of this collection using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    B

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection is nonempty.

    Exceptions thrown

      `UnsupportedOperationException` if this collection is empty.

47.  def reduceLeft[B >: A](op: (B, A) => B): B

    Applies a binary operator to all elements of this collection, going left to right.

    Applies a binary operator to all elements of this collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection, going left to right: `op( op( ... op(x1, x2) ..., xn-1), xn)` where `x1, ..., xn` are the elements of this collection.

    Exceptions thrown

      `UnsupportedOperationException` if this collection is empty.

48.  def reduceLeftOption[B >: A](op: (B, A) => B): Option[B]

    Optionally applies a binary operator to all elements of this collection, going left to right.

    Optionally applies a binary operator to all elements of this collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` if this collection is nonempty, `None` otherwise.

49.  def reduceOption[B >: A](op: (B, B) => B): Option[B]

    Reduces the elements of this collection, if any, using the specified associative binary operator.

    Reduces the elements of this collection, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    B

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

50.  def reduceRight[B >: A](op: (A, B) => B): B

    Applies a binary operator to all elements of this collection, going right to left.

    Applies a binary operator to all elements of this collection, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection, going right to left: `op(x1, op(x2, ..., op(xn-1, xn)...))` where `x1, ..., xn` are the elements of this collection.

    Exceptions thrown

      `UnsupportedOperationException` if this collection is empty.

51.  def reduceRightOption[B >: A](op: (A, B) => B): Option[B]

    Optionally applies a binary operator to all elements of this collection, going right to left.

    Optionally applies a binary operator to all elements of this collection, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` if this collection is nonempty, `None` otherwise.

52.  def reversed: Iterable[A]
    Attributes
      protected
53.  def size: Int

    The size of this collection.

    The size of this collection.

    Note: will not terminate for infinite-sized collections.

    returns

      the number of elements in this collection.

54.  def splitAt(n: Int): (C, C)

    Splits this collection into a prefix/suffix pair at a given position.

    Splits this collection into a prefix/suffix pair at a given position.

    Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the position at which to split.

    returns

      a pair of collections consisting of the first `n` elements of this collection, and the other elements.

55.  def sum[B >: A](implicit num: math.Numeric[B]): B

    Sums up the elements of this collection.

    Sums up the elements of this collection.

    Note: will not terminate for infinite-sized collections.

    B

      the result type of the `+` operator.

    num

      an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

    returns

      the sum of all elements of this collection with respect to the `+` operator in `num`.

56.  def to[C1](factory: Factory[A, C1]): C1

    Given a collection factory `factory`, convert this collection to the appropriate representation for the current element type `A`.

    Given a collection factory `factory`, convert this collection to the appropriate representation for the current element type `A`. Example uses:

    xs.to(List) xs.to(ArrayBuffer) xs.to(BitSet) // for xs: Iterable[Int]

57.  def toArray[B >: A](implicit arg0: ClassTag[B]): Array[B]

    Convert collection to array.

    Convert collection to array.

    Implementation note: DO NOT call Array.from from this method.

58.  final def toBuffer[B >: A]: Buffer[B]
    Annotations
      @inline()
59.  def toIndexedSeq: immutable.IndexedSeq[A]
60.  def toList: immutable.List[A]
61.  def toMap[K, V](implicit ev: <:<[A, (K, V)]): immutable.Map[K, V]
62.  def toSeq: immutable.Seq[A]

    returns

      This collection as a `Seq[A]`. This is equivalent to `to(Seq)` but might be faster.

63.  def toSet[B >: A]: immutable.Set[B]
64.  def toString(): String

    Returns a string representation of the object.

    Returns a string representation of the object.

    The default representation is platform dependent.

    returns

      a string representation of the object.

    Definition Classes
      Any
65.  def toVector: immutable.Vector[A]

### Deprecated Value Members

1.  final def /:[B](z: B)(op: (B, A) => B): B
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use foldLeft instead of /:

2.  final def :\[B](z: B)(op: (A, B) => B): B
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use foldRight instead of :\

3.  def aggregate[B](z: => B)(seqop: (B, A) => B, combop: (B, B) => B): B
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) `aggregate` is not relevant for sequential collections. Use `foldLeft(z)(seqop)` instead.

4.  final def copyToBuffer[B >: A](dest: Buffer[B]): Unit
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use `dest ++= coll` instead

5.  def hasDefiniteSize: Boolean

   Tests whether this collection is known to have a finite size.

   Tests whether this collection is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end. Non-empty Iterators usually return `false` even if they were created from a collection with a known finite size.

   Note: many collection methods will not work on collections of infinite sizes. The typical failure mode is an infinite loop. These methods always attempt a traversal without checking first that `hasDefiniteSize` returns `true`. However, checking `hasDefiniteSize` can provide an assurance that size is well-defined and non-termination is not a concern.

   returns

     `true` if this collection is known to have finite size, `false` otherwise.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Check .knownSize instead of .hasDefiniteSize for more actionable information (see scaladoc for details)

   See also

     method `knownSize` for a more useful alternative

6.  final def toIterator: Iterator[A]
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use .iterator instead of .toIterator

7.  final def toStream: immutable.Stream[A]
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use .to(LazyList) instead of .toStream

8.  def →[B](y: B): (IterableOnceOps[A, CC, C], B)
   Implicit
     This member is added by an implicit conversion from IterableOnceOps[A, CC, C] toArrowAssoc[IterableOnceOps[A, CC, C]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromIterableOnceOps[A, CC, C] to any2stringadd[IterableOnceOps[A, CC, C]]

### Inherited by implicit conversion StringFormat fromIterableOnceOps[A, CC, C] to StringFormat[IterableOnceOps[A, CC, C]]

### Inherited by implicit conversion Ensuring fromIterableOnceOps[A, CC, C] to Ensuring[IterableOnceOps[A, CC, C]]

### Inherited by implicit conversion ArrowAssoc fromIterableOnceOps[A, CC, C] to ArrowAssoc[IterableOnceOps[A, CC, C]]

### Ungrouped